using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using System.Collections;

namespace WindowsApplication131
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        ArrayList visibleRecordsIndex = new ArrayList();
        private void Form1_Load(object sender, EventArgs e)
        {

            #region Get the DataSource
            DataTable dt = new DataTable("MyTable");

            int nCols = 8;
            int nRows = 40;

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    dr[j] = string.Format("row{0} col{1}", i, j);
                dt.Rows.Add(dr);
            }

            #endregion

            this.gridDataBoundGrid1.DataSource = dt;

           this.gridDataBoundGrid1.Binder.LayoutColumns(new string[]{"+", "+","-","-","-","-","-","-",".", 
               "Col0", "Col1", "Col2", "Col3", "Col4", "Col5", "Col6", "Col7"});

           visibleRecordsIndex.AddRange(new int[] { 2*1, 2*4, 2*9 , 2*16, 2*25, 2*32}); //make some visible

           this.gridDataBoundGrid1.Model.QueryRowHeight += new GridRowColSizeEventHandler(Model_QueryRowHeight);
           this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(Model_QueryCellInfo);
        }

        void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            if (e.RowIndex > 0 && e.ColIndex > 0 &&
                visibleRecordsIndex.IndexOf(e.RowIndex) > -1)
            {
                switch (e.ColIndex)
                {
                    case 2:
                        e.Style.Interior = new BrushInfo(GradientStyle.Horizontal, Color.Red, Color.Blue);
                        e.Style.Text = string.Format("Record {0}", e.RowIndex / 2);
                        break;
                    case 1:
                        e.Style.CellValue = SystemIcons.Exclamation.ToBitmap();
                        e.Style.CellType = "Image";
                        break;
                    default:
                        break;
                }
            }
        }

        void Model_QueryRowHeight(object sender, GridRowColSizeEventArgs e)
        {
            if (e.Index % 2 == 0)
            {
                e.Size = 0;
                e.Handled = true;
               
                if (visibleRecordsIndex.IndexOf(e.Index) > -1)
                {
                    e.Size = gridDataBoundGrid1.DefaultRowHeight;
                }
            }
        }
    }
}